define class LogFileProcessorTest as FxuTestCase of FxuTestCase.prg
	#if .f.
		local this as LogFileProcessorTest of LogFileProcessorTest.PRG
	#endif

	icTestPrefix = 'Test'
	oObjectToTest = .NULL.
	
	function Setup
		This.oObjectToTest = newobject('LogFileProcessor', 'LogFileProcessor.prg')
	endfunc
	
	function TearDown
		erase x.log
	endfunc

	function TestIsValidFile_NoFileName_ReturnsFalse
		llResult = This.oObjectToTest.IsValidFile()
		This.AssertFalse(llResult)
	endfunc

	function TestIsValidFile_EmptyFileName_ReturnsFalse
		llResult = This.oObjectToTest.IsValidFile('')
		This.AssertFalse(llResult)
	endfunc

	function TestIsValidFile_InvalidExtension_ReturnsFalse
		llResult = This.oObjectToTest.IsValidFile('x.txt')
		This.AssertFalse(llResult)
	endfunc

	function TestIsValidFile_NonExistentFile_ReturnsFalse
		erase x.log
		llResult = This.oObjectToTest.IsValidFile('x.log')
		This.AssertFalse(llResult)
	endfunc

	function TestIsValidFile_EmptyFile_ReturnsFalse
		strtofile('', 'x.log')
		llResult = This.oObjectToTest.IsValidFile('x.log')
		This.AssertFalse(llResult)
	endfunc

	function TestIsValidFile_ValidFile_ReturnsTrue
		strtofile('some text', 'x.log')
		llResult = This.oObjectToTest.IsValidFile('x.log')
		This.AssertTrue(llResult)
	endfunc
enddefine
