define class NewLogFileProcessorTest as FxuTestCase of FxuTestCase.prg
	#if .f.
		local this as NewLogFileProcessorTest of NewLogFileProcessorTest.PRG
	#endif

	icTestPrefix = 'Test'
	oObjectToTest = .NULL.
	oMock = .NULL.

	function Setup
		This.oObjectToTest = newobject('LogFileProcessor', 'NewLogFileProcessor.prg')
	endfunc

	function TearDown
		erase x.log
	endfunc

	function TestImportLog_ImportXML_ReturnsCorrectValue
		text to lcLog noshow pretext 2
			<logs>
				<log>
					<date>01/01/2013</date>
					<type>2</type>
					<text>This is a log entry</text>
				</log>
				<log>
					<date>01/02/2013</date>
					<type>1</type>
					<text>This is another log entry</text>
				</log>
			</logs>
		endtext
		strtofile(lcLog, 'x.log')
		lnActual   = This.oObjectToTest.ImportLog('x.log')
		lnExpected = 2
		This.AssertEquals(lnExpected, lnActual, This.oObjectToTest.cErrorMessage)
	endfunc

	function TestImportLog_Import_ReturnsCorrectValue_UsingMock
		This.oObjectToTest.oParser = createobject('MockFileParser')
		lnActual   = This.oObjectToTest.ImportLog('x.log')
		lnExpected = 1
		This.AssertEquals(lnExpected, lnActual, This.oObjectToTest.cErrorMessage)
	endfunc
enddefine

define class MockFileParser as Custom
	function ParseFile(tcFile, tcCursor)
		create cursor (tcCursor) (DATE D, TYPE N(1), TEXT C(80))
		append blank
		return .T.
	endfunc
enddefine
