define class bizobjecttests as FxuTestCase of FxuTestCase.prg
	#if .f.
		local this as bizobjecttests of bizobjecttests.PRG
	#endif

	icTestPrefix = 'Test'
	oObjectToTest = .NULL.
	oMock = .NULL.

	function Setup
		This.oMock = newobject('FoxMock', 'FoxMock.prg')
		This.oObjectToTest = newobject('CustomerBO', 'BizObject.prg')
	endfunc

	function TearDown
	endfunc

	function TestGetCustomer_CantConnect_ReturnsNull
		loConn = This.oMock.New.Property('cErrorMessage').Is( ;
			"'cannot connect'").Method('Connect').Returns('.F.')
		This.oObjectToTest.oConnection = loConn
		loActual = This.oObjectToTest.GetCustomer()
		This.AssertTrue(isnull(loActual))
	endfunc

	function TestGetCustomer_CantExecute_ReturnsNull
		loConn = This.oMock.New.Property('cErrorMessage').Is( ;
			"'cannot execute'").Method('Connect').Returns('.T.').Method( ;
			'Execute').Returns('.F.')
		This.oObjectToTest.oConnection = loConn
		loActual = This.oObjectToTest.GetCustomer()
		This.AssertTrue(isnull(loActual))
	endfunc

	function TestGetCustomer_NoRecords_ReturnsNull
		create cursor Temp (Field1 C(1))
		loConn = This.oMock.New.Method('Connect').Returns('.T.').Method( ;
			'Execute').Returns('.T.')
		This.oObjectToTest.oConnection = loConn
		loActual = This.oObjectToTest.GetCustomer()
		This.AssertTrue(isnull(loActual))
		use in select('Temp')
	endfunc

	function TestGetCustomer_FindRecord_ReturnsObject
		create cursor Temp (Field1 C(1))
		insert into Temp values ('x')
		loConn = This.oMock.New.Method('Connect').Returns('.T.').Method( ;
			'Execute').Returns('.T.')
		This.oObjectToTest.oConnection = loConn
		loActual = This.oObjectToTest.GetCustomer()
		This.AssertNotNull(loActual)
		use in select('Temp')
	endfunc

	function TestGetCustomer_FindRecord_ReturnsValue
		create cursor Temp (Field1 C(1))
		insert into Temp values ('x')
		loConn = This.oMock.New.Method('Connect').Returns('.T.').Method( ;
			'Execute').Returns('.T.')
		This.oObjectToTest.oConnection = loConn
		loActual = This.oObjectToTest.GetCustomer()
		This.AssertEquals('x', loActual.Field1)
		use in select('Temp')
	endfunc
enddefine
