* Create a table to hold test results if necessary.

do case
	case used('TestResults')
	case file('TestResults.dbf')
		use TestResults in 0
	otherwise
		create table TestResults free (Test C(90), When T, Result L)
endcase

* Run the tests.

do Test1
do Test2
do Test3
do Test4
do Test5

* Display the results.

browse

* Helper method to log test results.

function LogResult(tcTest, tlResult)
insert into TestResults values (tcTest, datetime(), tlResult)

* Test that IsValidFile handles no filename.

function Test1
loClass  = newobject('LogFileProcessor', 'LogFileProcessor.prg')
llResult = not loClass.IsValidFile()
LogResult('IsValidFile handles no filename (no parameter)', llResult)
llResult = not loClass.IsValidFile('')
LogResult('IsValidFile handles no filename (empty parameter)', llResult)

* Test that IsValidFile handles an invalid extension.

function Test2
loClass  = newobject('LogFileProcessor', 'LogFileProcessor.prg')
llResult = not loClass.IsValidFile('x.txt')
LogResult('IsValidFile handles an invalid extension', llResult)

* Test that IsValidFile handles a non-existent file.

function Test3
loClass  = newobject('LogFileProcessor', 'LogFileProcessor.prg')
llResult = not loClass.IsValidFile('x.log')
LogResult('IsValidFile handles a non-existent file', llResult)

* Test that IsValidFile works.

function Test4
strtofile('some text', 'x.log')
loClass  = newobject('LogFileProcessor', 'LogFileProcessor.prg')
llResult = loClass.IsValidFile('x.log')
LogResult('IsValidFile works when all requirement met', llResult)
erase x.log

* Test that IsValidFile handles an empty file.

function Test5
strtofile('', 'x.log')
loClass  = newobject('LogFileProcessor', 'LogFileProcessor.prg')
llResult = not loClass.IsValidFile('x.log')
LogResult('IsValidFile handles an empty file', llResult)
erase x.log
