* Create a table to hold test results if necessary.

do case
	case used('TestResults')
	case file('TestResults.dbf')
		use TestResults in 0
	otherwise
		create table TestResults free (Test C(90), When T, Result L)
endcase

* Run the tests.

do IsValidFile_NoFileName_ReturnsFalse
do IsValidFile_InvalidExtension_ReturnsFalse
do IsValidFile_NonExistentFile_ReturnsFalse
do IsValidFile_EmptyFile_ReturnsFalse
do IsValidFile_ValidFile_ReturnsTrue

* Display the results.

browse

* Helper method to log test results.

function LogResult(tcTest, tlResult)
insert into TestResults values (tcTest, datetime(), tlResult)

* Helper method to instantiate the class under test.

function CreateFileProcessor
loClass = newobject('LogFileProcessor', 'LogFileProcessor.prg')
return loClass

* Test functions.

function IsValidFile_NoFileName_ReturnsFalse
loClass  = CreateFileProcessor()
llResult = not loClass.IsValidFile()
LogResult('IsValidFile handles no filename (no parameter)', llResult)
llResult = not loClass.IsValidFile('')
LogResult(program(), llResult)

function IsValidFile_InvalidExtension_ReturnsFalse
loClass  = CreateFileProcessor()
llResult = not loClass.IsValidFile('x.txt')
LogResult(program(), llResult)

function IsValidFile_NonExistentFile_ReturnsFalse
loClass  = CreateFileProcessor()
llResult = not loClass.IsValidFile('x.log')
LogResult(program(), llResult)

function IsValidFile_EmptyFile_ReturnsFalse
strtofile('', 'x.log')
loClass  = CreateFileProcessor()
llResult = not loClass.IsValidFile('x.log')
LogResult(program(), llResult)
erase x.log

function IsValidFile_ValidFile_ReturnsTrue
strtofile('some text', 'x.log')
loClass  = CreateFileProcessor()
llResult = loClass.IsValidFile('x.log')
LogResult(program(), llResult)
erase x.log
