* Erase the log file in case it exists.

erase x.log

* Instantiate the class.

loClass = newobject('LogFileProcessor', 'LogFileProcessor.prg')

* Test that IsValidFile handles no filename.

llResult = loClass.IsValidFile()
if llResult or loClass.cErrorMessage <> 'Invalid filename'
	messagebox('First test failed')
	return
endif
llResult = loClass.IsValidFile('')
if llResult or loClass.cErrorMessage <> 'Invalid filename'
	messagebox('Second test failed')
	return
endif

* Test that IsValidFile handles an invalid extension.

llResult = loClass.IsValidFile('x.txt')
if llResult or loClass.cErrorMessage <> 'Not a log file'
	messagebox('Third test failed')
	return
endif

* Test that IsValidFile handles a non-existent file.

llResult = loClass.IsValidFile('x.log')
if llResult or loClass.cErrorMessage <> 'File does not exist'
	messagebox('Fourth test failed')
	return
endif

* Test that IsValidFile works.

*!* * Removed 07/16/2013
*!* strtofile('', 'x.log')
*!* llResult = loClass.IsValidFile('x.log')
*!* if not llResult
*!* 	messagebox('Fifth test failed')
*!* 	return
*!* endif

* Test that IsValidFile handles an empty file.

strtofile('', 'x.log')
llResult = loClass.IsValidFile('x.log')
if llResult or loClass.cErrorMessage <> 'File is empty'
	messagebox('Fifth test failed')
	return
endif

* Test that IsValidFile works.

strtofile('some text', 'x.log')
llResult = loClass.IsValidFile('x.log')
if not llResult
	messagebox('Sixth test failed')
	return
endif


erase x.log
messagebox('All tests passed')
