define class LogFileProcessor as Custom
	cErrorMessage = ''
	oParser = .NULL.
	nLogType = 1

	function IsValidFile(tcFileName)
		local llReturn
		do case
			case vartype(tcFileName) <> 'C' or empty(tcFileName)
				This.cErrorMessage = 'Invalid filename'
				llReturn = .F.
			case lower(justext(tcFileName)) <> 'log'
				This.cErrorMessage = 'Not a log file'
				llReturn = .F.
			case not file(tcFileName)
				This.cErrorMessage = 'File does not exist'
				llReturn = .F.
			case empty(filetostr(tcFileName))
				This.cErrorMessage = 'File is empty'
				llReturn = .F.
			otherwise
				llReturn = .T.
		endcase
		return llReturn
	endfunc

	function ImportLog(tcFileName)
		if vartype(This.oParser) <> 'O'
			This.cErrorMessage = 'oParser was not set to a parser object'
			return -1
		endif
		*!* * Removed 07/16/2013
		*!* if This.nLogType = 1
		*!* 	This.oParser = createobject('XMLFileParser')
		*!* else
		*!* 	This.oParser = createobject('CSVFileParser')
		*!* endif
		lnSelect = select()
		lcCursor = sys(2015)
		lnResult = -1
		llOK     = This.oParser.ParseFile(tcFileName, lcCursor)
		if llOK
			lnResult = This.ProcessFile(lcCursor)
			use in (lcCursor)
		else
			This.cErrorMessage = This.oParser.cErrorMessage
		endif
		select (lnSelect)
		return lnResult
	endfunc

	function ProcessFile(tcCursor)
		return reccount(tcCursor)
	endfunc
enddefine

define class FileParser as Custom
	cErrorMessage = ''

	function ParseFile(tcFile, tcCursor)
		return .T.
	endfunc
enddefine

define class CSVFileParser as FileParser
	function ParseFile(tcFile, tcCursor)
		create cursor (tcCursor) (DATE D, TYPE N(1), TEXT C(80))
		append from (tcFile) delimited
		return .T.
	endfunc
enddefine

define class XMLFileParser as FileParser
	function ParseFile(tcFile, tcCursor)
		try
			xmltocursor(tcFile, tcCursor, 512)
			llReturn = .T.
		catch to loException
			This.cErrorMessage = loException.Message
			llReturn = .F.
		endtry
		return llReturn
	endfunc
enddefine
